;--------------------------------------------------------------------------
;
;                          COPYRIGHT 1998 , 1999 - MOTOROLA INC.
;
;--------------------------------------------------------------------------
    page    132,55,0,0,0
    nolist
    INCLUDE "/home/sabres/nde/docs/sio/ioequ.asm"
    INCLUDE "/home/sabres/nde/docs/sio/intequ.asm"
    list

;--------------------------------------------------------------------------
; EQUATES
;--------------------------------------------------------------------------
START       		equ $100
HOST_COMMAND_EF     equ $ee         ; Host Command Interrupt Vector Address
HOST_COMMAND_F1     equ $f0         ; Host Command Interrupt Vector Address
HOST_COMMAND_F3     equ $f2         ; Host Command Interrupt Vector Address
HOST_COMMAND_F5     equ $f4         ; Host Command Interrupt Vector Address
HOST_COMMAND_F7     equ $f6         ; Host Command Interrupt Vector Address
HOST_COMMAND_F9     equ $f8         ; Host Command Interrupt Vector Address
HOST_COMMAND_FB     equ $fa         ; Host Command Interrupt Vector Address
HOST_COMMAND_FD     equ $fc         ; Host Command Interrupt Vector Address
HOST_COMMAND_FF     equ $fe         ; Host Command Interrupt Vector Address
;--------------------------------------------------------------------------
; start of program area
;--------------------------------------------------------------------------
    org p:I_RESET       ;Hardware RESET
    jmp >START

    dup (I_INTEND-*+1)      ;fill vector space
    jmp <*
    endm

; Interrupt Vectors

; Host Commands Interrupts
    org P:HOST_COMMAND_EF   ; Personal Reset: Mode 0 -> Wait for HACT = 0 -> PCI Mode
	jsr <personal_reset
    nop
 
	org P:HOST_COMMAND_F1	; set interrupt index to $2
    bset    #3,x:M_DCTR 
	nop
	org P:HOST_COMMAND_F3	; set interrupt index to $3
    bclr    #3,x:M_DCTR 
	nop
	org P:HOST_COMMAND_F5	; set interrupt index to $4
    bset    #4,x:M_DCTR 
	nop
	org P:HOST_COMMAND_F7	; set interrupt index to $5
    bclr    #4,x:M_DCTR 
	nop
	org P:HOST_COMMAND_F9	; set interrupt index to $6
    bset    #5,x:M_DCTR 
	nop
	org P:HOST_COMMAND_FB	; set interrupt index to $7
    bclr    #5,x:M_DCTR 
	nop

    org P:HOST_COMMAND_FD
    bset    #6,x:M_DCTR ; ASSERT HI32 PCI interrupt line (HINTA)
    nop 

    org P:HOST_COMMAND_FF
    bclr    #6,x:M_DCTR ; Deassert HI32 PCI interrupt line (HINTA)
    nop

    org p:(I_INTEND+1)
    dup (START-I_INTEND-1)  ;fill with nops
    nop
    endm
;--------------------------------------------------------------------------
    org P:START

    move    #$0,x1      		;clear N1 for flagging
    move    #$0,sr          	; enable interrupts
    movep   #$000003,x:M_IPRP   ; HI32's IPL=2
    movep   #$03f000,x:M_IPRC   ; DMA's IPL=2, channels #0 and #1 and #2

;Program DMA channel #0 for output
    movep   #$500,x:M_DSR0
    movep   #>M_DTXS,x:M_DDR0
    movep   #(-$1f),x:M_DOR0
    movep   #$00001f,x:M_DCO0

;Program DMA channel #1 for input
    movep   #>M_DRXR,x:M_DSR1
    movep   #$700,x:M_DDR1
    movep   #(-$1f),x:M_DOR1
    movep   #$00001f,x:M_DCO1

; PCI personal reset, HI32 PCI-mode, HCIE set, MACE=1 , MAIE = 1

    movep   #>$000000,x:M_DCTR ; HM=$0 (Personal s/w reset)
    nop
    nop
    jset	#M_HACT,x:M_DSR,*       ; wait for personal reset
    movep   #>$000000,x:M_DPCR ;
    movep   #>$100001,x:M_DCTR ; HM=$1 ,HCIE=$1

; sum up checksum and sends to HOST

    move    #$0,r1
    clr 	a
    clr 	b
    do  	#(the_end+1),loop1
    move    p:(r1)+,b1
    add 	b,a
    nop
    nop
loop1
    nop
    nop
wait_for_request
    brclr   #M_STRQ,x:M_DSR,wait_for_request   ; Write data to FIFO
    movep   a1,x:M_DTXS
	nop

;Activate DMA Channel #0 for OUTPUT
;               DDDDDDDDDDD DDDDDDDDDD
;              DTTTPPCRRRRRDAAAAAADDSS
;             DIMMMRROSSSSS3MMMMMMSSSS
;             EE21010N43210D5432101010
;             ||||||||||||||||||||||||
    movep   #%101011101111001000000010,x:M_DCR0
;Activate DMA Channel #1 for INPUT
;               DDDDDDDDDDD DDDDDDDDDD
;              DTTTPPCRRRRRDAAAAAADDSS
;             DIMMMRROSSSSS3MMMMMMSSSS
;             EE21010N43210D5432101010
;             ||||||||||||||||||||||||
    movep   #%101011101110000011001000,x:M_DCR1
	nop
	nop
	nop
	nop
	jmp		*
	nop
	nop
	nop
;-----------------------------------------------------------------------------
personal_reset
    ; PCI personal reset, HI32 PCI-mode, HCIE set, MACE=1 , MAIE = 1
	movep   #>$000000,x:M_DCTR  ; HM=$0 (Personal s/w reset)
	nop
	nop
	jset    #M_HACT,x:M_DSR,*   ; wait for personal reset
	movep   #>$100001,x:M_DCTR  ; HM=$1 ,HCIE=$1
    ; send interrupt #1
	brset   #M_HINT,x:M_DCTR,*  ; polling for no int is pending
	bset    #M_HF3,x:M_DCTR
	bclr    #M_HF4,x:M_DCTR
	bclr    #M_HF5,x:M_DCTR
	bset    #M_HINT,x:M_DCTR            ; assert HINTA
	; return from interrupt
	nop
	rti
;-----------------------------------------------------------------------------
    org P:$500    ; output data
	dc	$fe0000
	dc	$fe0001
	dc	$fe0002
	dc	$fe0003
	dc	$fe0004
	dc	$fe0005
	dc	$fe0006
	dc	$fe0007
	dc	$fe0008
	dc	$fe0009
	dc	$fe000a
	dc	$fe000b
	dc	$fe000c
	dc	$fe000d
	dc	$fe000e
	dc	$fe000f
    dc  $fe0010
    dc  $fe0011
    dc  $fe0012
    dc  $fe0013
    dc  $fe0014
    dc  $fe0015
    dc  $fe0016
    dc  $fe0017
    dc  $fe0018
    dc  $fe0019
    dc  $fe001a
    dc  $fe001b
    dc  $fe001c
    dc  $fe001d
    dc  $fe001e
    dc  $fe001f


    org P:$600    ; input data
    nop

    org P:$800
	nop
the_end
