/*********************************************************************
*                     crescent engineering                           *
*                     P.O. Box 1863                                  *	
*                     Montclair, NJ 07042                            *
*                     (C) Copyright 1994                             *
*********************************************************************/

/*
 *	Host code for simple delay line example.  (Borland C)
 */


#include "multisound.h"

#ifdef __linux__
#include "linkbd.h"
#endif

#define SAMPLE_RATE 44100.0
#define CHUNK_SIZE 4.0

void main(int argc,char** argv)
{
	  
	char input_buffer[1020], param;
	char bootc[255];
	char debc[255];
	char progc[255];
	int i,n;
	int pc,num_ops;
	char* output_string[255];
	LONG op,op2;
	double x, delay_amt=0.0;

	#ifdef __linux__
	init_term();
	#endif
					

	debc[0]=progc[0]=bootc[0]='\0';

	if (argc < 2) { 
	  printf("Usage: mdb program\n");
	  exit(-1);
	}


	strcpy(bootc,MDBLIBDIR"/multisound.lod");

	strcpy(debc,MDBLIBDIR"/debug.lod");

	for (i=1;i<argc;i++) {
	  if (*argv[i] == '-') {
	    argv[i]++;
	    if (*argv[i] == 'c')
	      strcpy(bootc,MDBLIBDIR"/clean.lod");
	    else if (*argv[i] == 'd')
	      strcpy(debc,MDBLIBDIR"/debug.lod");
	  }
	  else {
	    fprintf(stderr,"debugging %s ...\n",argv[i]);
	    strncpy(progc,argv[i],255);
	  }
	}


	if (progc[0] == '\0') { 
	  printf("Usage: mdb  program\n");
	  exit(-1);
	}

	maas_init();


	if (ioperm(DSP_BASE,0xf,1)) {
	  fprintf(stderr,"Must be root to access the DSP IO ports\n");
	  exit(-1);
	}


	boot_dsp(bootc);		   /* load boot code */
	
	pc = 0;
	for (n=0; n<16; n++)
	  {	
	    (void) set_dsp_read_ptr(P, pc);
	    (void) read_dsp_data(&op);
	    (void) read_dsp_data(&op2);
	    op  &= 0x00FFFFFF;
	    op2 &= 0x00FFFFFF;
	    num_ops = Disassemble(op, op2, output_string);
	    
	    if (num_ops > 1)
	      {
		(void) fprintf(stderr, " p:%04lX  %06lX %06lX    %s\n", pc, op, op2, output_string);
		pc += 2;
	      }
	    else
	      {
		(void) fprintf(stderr, " p:%04lX  %06lX           %s\n", pc, op, output_string);
		pc++;
	      }
	  }
	
	fprintf(stderr,"Loading debugger .. ");
	load_dsp_application(debc);	 
	fprintf(stderr,"done\n");
	
	fprintf(stderr,"Loading %s .. ",progc);
	load_dsp_application(progc);	  
	fprintf(stderr,"done\n");
	
;	set_input_pot_level(0.0, 0.0);		  /* set pots to 0 dB full scale */
;	set_aux_pot_level(0.0, 0.0);		 /*    relative to 1 V rms */


	dspbugger('?');	       
	
	maas_exit();
}




