#include <stdio.h>

#include <sys/types.h>
#include <sys/mman.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <asm/page.h>


main (int argc,char **argv){
 int fd;
 char *buf;  
 int i;

 int mem_fd;
 unsigned char *dsp_mem;


 if(( fd = open("./maab0",O_RDWR) ) < 0 ){
   printf("Open error\n");
   exit(1);
 }
   
 /*caddr_t  mmap(caddr_t  addr,  size_t  len,  int prot , int
                          flags, int fd, off_t offset );*/
     
 
 if((dsp_mem = (unsigned char*) malloc((0x20l)+(PAGE_SIZE-1))) == NULL){
   printf("DSP mem allocation error\n");
   exit(1);
 }
 
 if((unsigned long) dsp_mem %PAGE_SIZE)
   dsp_mem+= PAGE_SIZE -((unsigned long)dsp_mem % PAGE_SIZE);
  

 if((buf = mmap((caddr_t) dsp_mem,
		0x20l,
		PROT_WRITE|PROT_READ,MAP_SHARED|MAP_FILE,
		fd,0)) < 0){
   printf("MMAP error %d",buf);  
   exit(1);
 }

 printf("Buffer=%lx\n",buf);
 for (i=0;i<0x1C;i+=0x4)   
   printf("Register %02x= %02x %02x %02x %02x\n",
	  i,*(buf+i+3),*(buf+i+2),
	  *(buf+i+1),*(buf+i));

 close(fd);
 /*
   if( argc>1 ) {
     printf("Writing '%s' to the driver\n",argv[1]);
     sprintf(buf2,"%s",argv[1]);
     }
 */

 if((mem_fd = open("/dev/mem",O_RDWR)) < 0){
   printf("no memory ops\n");
   exit(1);
 }

 dsp_mem = (unsigned char *) mmap((caddr_t) dsp_mem,
			  0x20l,
			  PROT_WRITE|PROT_READ,MAP_SHARED|MAP_FIXED,
			  mem_fd, 
			  0xfbff0000l
			  );
 if((long) dsp_mem < 0){
   printf("dsp mem mapping error\n");
   exit(1);
 }

 
 printf("DSP mem mapping:\n");
 for (i=0;i<0x1C;i+=0x4)   
   printf("Register %02x= %02x %02x %02x %02x\n",
	  i,*(dsp_mem+i+3),*(dsp_mem+i+2),
	  *(dsp_mem+i+1),*(dsp_mem+i));

 close(mem_fd);
   
}






